local t=require"luci.passwall.api"
local i="passwall"
local n=t.datatypes
local e=require"luci.model.network".init()
local a={}
for t,e in ipairs(t.get_valid_nodes())do
if e.node_type=="normal"then
a[#a+1]={
id=e[".name"],
obj=e,
remarks=e["remark"]
}
end
end
m=Map(i)
t.set_apply_on_parse(m)
s=m:section(TypedSection,"global_haproxy",translate("Basic Settings"))
s.anonymous=true
s:append(Template(i.."/haproxy/status"))
o=s:option(Flag,"balancing_enable",translate("Enable Load Balancing"))
o.rmempty=false
o.default=false
o=s:option(Flag,"console_auth",translate("Console Login Auth"))
o.default=false
o:depends("balancing_enable",true)
o=s:option(Value,"console_user",translate("Console Username"))
o.default=""
o:depends("console_auth",true)
o=s:option(Value,"console_password",translate("Console Password"))
o.password=true
o.default=""
o:depends("console_auth",true)
o=s:option(Value,"console_port",translate("Console Port"),translate(
"In the browser input routing IP plus port access, such as:192.168.1.1:1188"))
o.default="1188"
o:depends("balancing_enable",true)
o=s:option(Flag,"bind_local",translate("Haproxy Port").." "..translate("Bind Local"),translate("When selected, it can only be accessed localhost."))
o.default="0"
o:depends("balancing_enable",true)
o=s:option(ListValue,"health_check_type",translate("Health Check Type"))
o.default="passwall_logic"
o:value("tcp","TCP")
o:value("passwall_logic",translate("URL Test")..string.format("(passwall %s)",translate("Inner implement")))
o:depends("balancing_enable",true)
o=s:option(Value,"health_probe_url",translate("Probe URL"))
o.default="https://www.google.com/generate_204"
o:value("https://cp.cloudflare.com/","Cloudflare")
o:value("https://www.gstatic.com/generate_204","Gstatic")
o:value("https://www.google.com/generate_204","Google")
o:value("https://www.youtube.com/generate_204","YouTube")
o:value("https://connect.rom.miui.com/generate_204","MIUI (CN)")
o:value("https://connectivitycheck.platform.hicloud.com/generate_204","HiCloud (CN)")
o.description=translate("The URL used to detect the connection status.")
o:depends("health_check_type","passwall_logic")
o=s:option(Value,"health_check_inter",translate("Health Check Inter"),translate("Units:seconds"))
o.default="60"
o:depends("balancing_enable",true)
o=s:option(DummyValue,"health_check_tips"," ")
o.rawhtml=true
o.cfgvalue=function(e,e)
return string.format('<span style="color: red">%s</span>',translate("When the URL test is used, the load balancing node will be converted into a Socks node. when node list set customizing, must be a Socks node, otherwise the health check will be invalid."))
end
o:depends("health_check_type","passwall_logic")
s=m:section(TypedSection,"haproxy_config",translate("Node List"),
"<font color='red'>"..
translate("Add a node, Export Of Multi WAN Only support Multi Wan. Load specific gravity range 1-256. Multiple primary servers can be load balanced, standby will only be enabled when the primary server is offline! Multiple groups can be set, Haproxy port same one for each group.")..
"\n"..translate("Note that the node configuration parameters for load balancing must be consistent when use TCP health check type, otherwise it cannot be used normally!")..
"</font>")
s.template="cbi/tblsection"
s.sortable=true
s.anonymous=true
s.addremove=true
s.create=function(e,a)
TypedSection.create(e,t.gen_short_uuid())
end
s.remove=function(t,a)
for t,e in pairs(t.children)do
e.rmempty=true
e.validate=nil
end
TypedSection.remove(t,a)
end
o=s:option(Flag,"enabled",translate("Enable"))
o.default=1
o.rmempty=false
o=s:option(Value,"lbss",translate("Node Address"))
for t,e in pairs(a)do o:value(e.id,e.remarks)end
o.rmempty=false
o.validate=function(a,e)
if not e then return nil end
local a=m:get(e)or nil
if a and a[".type"]=="nodes"then
return e
end
if n.hostport(e)or n.ip4addrport(e)then
return e
end
if t.is_ipv6addrport(e)then
return e
end
return nil,e
end
o=s:option(Value,"haproxy_port",translate("Haproxy Port"))
o.datatype="port"
o.default=1181
o.rmempty=false
o=s:option(Value,"lbweight",translate("Node Weight"))
o.datatype="uinteger"
o.default=5
o.rmempty=false
o=s:option(ListValue,"export",translate("Export Of Multi WAN"))
o:value(0,translate("Auto"))
local e=require"luci.tools.webadmin"
e.cbi_add_networks(o)
o.default=0
o.rmempty=false
o=s:option(ListValue,"backup",translate("Mode"))
o:value(0,translate("Primary"))
o:value(1,translate("Standby"))
o.rmempty=false
return m
