local e=require"luci.passwall.api"
local i="passwall"
local n=e.sys
local d=e.datatypes
m=Map(i)
e.set_apply_on_parse(m)
s=m:section(TypedSection,"global_other")
s.anonymous=true
o=s:option(ListValue,"auto_detection_time",translate("Automatic detection delay"))
o:value("0",translate("Close"))
o:value("icmp","Ping")
o:value("tcping","TCP Ping")
o.description=translate("To optimize performance, auto-detection is disabled when there are more than 30 nodes.")
o=s:option(Flag,"show_node_info",translate("Show server address and port"))
o.default="0"
s:append(Template(i.."/node_list/link_add_node"))
local h=m:get("@global_other[0]","auto_detection_time")or"0"
local r=m:get("@global_other[0]","show_node_info")or"0"
if h~="0"then
local t=0
for a,e in ipairs(e.get_valid_nodes())do
if e.node_type=="normal"then
t=t+1
end
end
if t>30 then h="0"end
end
local t=s:option(DummyValue,"_auto_detection_time")
t.rawhtml=true
t.default=string.format([[
	<script>
		window.auto_detection_time = "%s";
	</script>
]],h)
s=m:section(TypedSection,"nodes")
s.anonymous=true
s.addremove=true
s.template="cbi/tblsection"
s.extedit=e.url("node_config","%s")
function s.create(a,t)
local e=e.gen_short_uuid()
t=e
TypedSection.create(a,t)
luci.http.redirect(a.extedit:format(t))
end
function s.remove(o,e)
m.uci:foreach(i,"socks",function(t)
if t["node"]==e then
m:del(t[".name"])
end
for o,a in ipairs(m:get(t[".name"],"autoswitch_backup_node")or{})do
if a and a==e then
n.call(string.format("uci -q del_list %s.%s.autoswitch_backup_node='%s'",i,t[".name"],a))
end
end
end)
m.uci:foreach(i,"haproxy_config",function(t)
if t["lbss"]and t["lbss"]==e then
m:del(t[".name"])
end
end)
m.uci:foreach(i,"acl_rule",function(t)
if t["tcp_node"]and t["tcp_node"]==e then
m:set(t[".name"],"tcp_node","default")
end
if t["udp_node"]and t["udp_node"]==e then
m:set(t[".name"],"udp_node","default")
end
end)
TypedSection.remove(o,e)
local t=""
local a=m:get("@nodes[0]")or nil
if a then
t=a[".name"]
end
if(m:get("@global[0]","tcp_node")or"")==e then
m:set('@global[0]',"tcp_node",t)
end
if(m:get("@global[0]","udp_node")or"")==e then
m:set('@global[0]',"udp_node",t)
end
end
s.sortable=true
t=s:option(DummyValue,"add_from","")
t.cfgvalue=function(e,a)
local e=Value.cfgvalue(e,a)
if e and e~=''then
local t=m:get(a,"group")or""
if t~=""then
e=e.." "..t
end
return e
else
return''
end
end
t=s:option(DummyValue,"remarks",translate("Remarks"))
t.rawhtml=true
t.cfgvalue=function(e,o)
local a=""
local e=m:get(o,"is_sub")or""
local e=m:get(o,"group")or""
local h=m:get(o,"remarks")or""
local n=m:get(o,"type")or""
a=a..string.format("<input type='hidden' id='cbid.%s.%s.type' value='%s'/>",i,o,n)
if n=="sing-box"or n=="Xray"then
local e=m:get(o,"protocol")
if e=="_balancing"then
e=translate("Balancing")
elseif e=="_urltest"then
e="URLTest"
elseif e=="_shunt"then
e=translate("Shunt")
elseif e=="vmess"then
e="VMess"
elseif e=="vless"then
e="VLESS"
elseif e=="shadowsocks"then
e="SS"
elseif e=="shadowsocksr"then
e="SSR"
elseif e=="wireguard"then
e="WG"
elseif e=="hysteria"then
e="HY"
elseif e=="hysteria2"then
e="HY2"
else
e=e:gsub("^%l",string.upper)
end
if n=="sing-box"then n="Sing-Box"end
n=n.." "..e
end
local e=m:get(o,"address")or""
local s=m:get(o,"port")or""
a=a..translate(n).."："..h
if e~=""and s~=""then
if r=="1"then
if d.ip6addr(e)then
a=a..string.format("（[%s]:%s）",e,s)
else
a=a..string.format("（%s:%s）",e,s)
end
end
a=a..string.format("<input type='hidden' id='cbid.%s.%s.address' value='%s'/>",i,o,e)
a=a..string.format("<input type='hidden' id='cbid.%s.%s.port' value='%s'/>",i,o,s)
end
return a
end
t=s:option(DummyValue,"ping","Ping")
t.width="8%"
t.rawhtml=true
t.cfgvalue=function(a,e)
local o=m:get(e,"type")or""
local a=m:get(e,"protocol")or""
if(o=="sing-box"or o=="Xray")and
(a=="_shunt"or a=="_balancing"or a=="_urltest"or a=="_iface")then
return string.format('<span class="ping_value" cbiid="%s">---</span>',e)
end
if h~="icmp"then
return string.format('<span class="ping"><a href="javascript:void(0)" onclick="javascript:ping_node(\'%s\', this, \'icmp\')">%s</a></span>',e,translate("Test"))
else
return string.format('<span class="ping_value" cbiid="%s">---</span>',e)
end
end
t=s:option(DummyValue,"tcping","TCPing")
t.width="8%"
t.rawhtml=true
t.cfgvalue=function(a,e)
local o=m:get(e,"type")or""
local a=m:get(e,"protocol")or""
if(o=="sing-box"or o=="Xray")and
(a=="_shunt"or a=="_balancing"or a=="_urltest"or a=="_iface")then
return string.format('<span class="tcping_value" cbiid="%s">---</span>',e)
end
if h~="tcping"then
return string.format('<span class="ping"><a href="javascript:void(0)" onclick="javascript:ping_node(\'%s\', this, \'tcping\')">%s</a></span>',e,translate("Test"))
else
return string.format('<span class="tcping_value" cbiid="%s">---</span>',e)
end
end
t=s:option(DummyValue,"_url_test",translate("URL Test"))
t.width="8%"
t.rawhtml=true
t.cfgvalue=function(t,e)
return string.format('<span class="ping"><a href="javascript:void(0)" onclick="javascript:urltest_node(\'%s\', this)">%s</a></span>',e,translate("Test"))
end
m:append(Template(i.."/node_list/node_list"))
return m
