local e=require"luci.passwall.api"
local t="passwall"
local i=e.finded_com("xray")
local a=e.finded_com("sing-box")
m=Map(t)
e.set_apply_on_parse(m)
s=m:section(TypedSection,"global_rules",translate("Rule status"))
s.anonymous=true
o=s:option(DynamicList,"gfwlist_url",translate("GFW domains(gfwlist) Update URL"))
o:value("https://fastly.jsdelivr.net/gh/YW5vbnltb3Vz/domain-list-community@release/gfwlist.txt",translate("v2fly/domain-list-community"))
o:value("https://fastly.jsdelivr.net/gh/Loyalsoldier/v2ray-rules-dat@release/gfw.txt",translate("Loyalsoldier/v2ray-rules-dat"))
o:value("https://fastly.jsdelivr.net/gh/Loukky/gfwlist-by-loukky/gfwlist.txt",translate("Loukky/gfwlist-by-loukky"))
o:value("https://fastly.jsdelivr.net/gh/gfwlist/gfwlist/gfwlist.txt",translate("gfwlist/gfwlist"))
o.default="https://fastly.jsdelivr.net/gh/Loyalsoldier/v2ray-rules-dat@release/gfw.txt"
o=s:option(DynamicList,"chnroute_url",translate("China IPs(chnroute) Update URL"))
o:value("https://fastly.jsdelivr.net/gh/gaoyifan/china-operator-ip@ip-lists/china.txt",translate("gaoyifan/china-operator-ip/china"))
o:value("https://ispip.clang.cn/all_cn.txt",translate("Clang.CN"))
o:value("https://ispip.clang.cn/all_cn_cidr.txt",translate("Clang.CN.CIDR"))
o:value("https://fastly.jsdelivr.net/gh/soffchen/GeoIP2-CN@release/CN-ip-cidr.txt",translate("soffchen/GeoIP2-CN"))
o:value("https://fastly.jsdelivr.net/gh/Hackl0us/GeoIP2-CN@release/CN-ip-cidr.txt",translate("Hackl0us/GeoIP2-CN"))
o=s:option(DynamicList,"chnroute6_url",translate("China IPv6s(chnroute6) Update URL"))
o:value("https://fastly.jsdelivr.net/gh/gaoyifan/china-operator-ip@ip-lists/china6.txt",translate("gaoyifan/china-operator-ip/china6"))
o:value("https://ispip.clang.cn/all_cn_ipv6.txt",translate("Clang.CN.IPv6"))
o=s:option(DynamicList,"chnlist_url",translate("China List(Chnlist) Update URL"))
o:value("https://fastly.jsdelivr.net/gh/felixonmars/dnsmasq-china-list/accelerated-domains.china.conf",translate("felixonmars/domains.china"))
o:value("https://fastly.jsdelivr.net/gh/felixonmars/dnsmasq-china-list/apple.china.conf",translate("felixonmars/apple.china"))
o:value("https://fastly.jsdelivr.net/gh/felixonmars/dnsmasq-china-list/google.china.conf",translate("felixonmars/google.china"))
o:value("https://fastly.jsdelivr.net/gh/Loyalsoldier/v2ray-rules-dat@release/china-list.txt",translate("Loyalsoldier/china-list"))
o:value("https://fastly.jsdelivr.net/gh/Loyalsoldier/v2ray-rules-dat@release/apple-cn.txt",translate("Loyalsoldier/apple-cn"))
o:value("https://fastly.jsdelivr.net/gh/Loyalsoldier/v2ray-rules-dat@release/google-cn.txt",translate("Loyalsoldier/google-cn"))
if i or a then
o=s:option(ListValue,"geoip_url",translate("GeoIP Update URL"))
o:value("https://api.github.com/repos/Loyalsoldier/v2ray-rules-dat/releases/latest",translate("Loyalsoldier/geoip"))
o:value("https://api.github.com/repos/MetaCubeX/meta-rules-dat/releases/latest",translate("MetaCubeX/geoip"))
o.default="https://api.github.com/repos/Loyalsoldier/v2ray-rules-dat/releases/latest"
o=s:option(ListValue,"geosite_url",translate("Geosite Update URL"))
o:value("https://api.github.com/repos/Loyalsoldier/v2ray-rules-dat/releases/latest",translate("Loyalsoldier/geosite"))
o:value("https://api.github.com/repos/MetaCubeX/meta-rules-dat/releases/latest",translate("MetaCubeX/geosite"))
o.default="https://api.github.com/repos/Loyalsoldier/v2ray-rules-dat/releases/latest"
o=s:option(Value,"v2ray_location_asset",translate("Location of Geo rule files"),translate("This variable specifies a directory where geoip.dat and geosite.dat files are."))
o.default="/usr/share/v2ray/"
o.placeholder="/usr/share/v2ray/"
o.rmempty=false
if e.is_finded("geoview")then
o=s:option(Flag,"enable_geoview",translate("Enable Geo Data Parsing"))
o.default=0
o.rmempty=false
o.description="<ul>"
.."<li>"..translate("Experimental feature.").."</li>"
.."<li>".."1."..translate("Analyzes and preloads GeoIP/Geosite data to enhance the shunt performance of Sing-box/Xray.").."</li>"
.."<li>".."2."..translate("Once enabled, the rule list can support GeoIP/Geosite rules.").."</li>"
.."<li>"..translate("Note: Increases resource usage; Geosite analysis is only supported in ChinaDNS-NG and SmartDNS modes.").."</li>"
.."</ul>"
end
end
o=s:option(Flag,"auto_update",translate("Enable auto update rules"))
o.default=0
o.rmempty=false
o=s:option(ListValue,"week_update",translate("Update Mode"))
o:value(8,translate("Loop Mode"))
o:value(7,translate("Every day"))
o:value(1,translate("Every Monday"))
o:value(2,translate("Every Tuesday"))
o:value(3,translate("Every Wednesday"))
o:value(4,translate("Every Thursday"))
o:value(5,translate("Every Friday"))
o:value(6,translate("Every Saturday"))
o:value(0,translate("Every Sunday"))
o.default=7
o:depends("auto_update",true)
o.rmempty=true
o=s:option(ListValue,"time_update",translate("Update Time(every day)"))
for e=0,23 do o:value(e,e..":00")end
o.default=0
o:depends("week_update","0")
o:depends("week_update","1")
o:depends("week_update","2")
o:depends("week_update","3")
o:depends("week_update","4")
o:depends("week_update","5")
o:depends("week_update","6")
o:depends("week_update","7")
o.rmempty=true
o=s:option(ListValue,"interval_update",translate("Update Interval(hour)"))
for e=1,24 do o:value(e,e.." "..translate("hour"))end
o.default=2
o:depends("week_update","8")
o.rmempty=true
s:append(Template(t.."/rule/rule_version"))
if i or a then
s=m:section(TypedSection,"shunt_rules","Sing-Box/Xray "..translate("Shunt Rule"),"<a style='color: red'>"..translate("Please note attention to the priority, the higher the order, the higher the priority.").."</a>")
s.template="cbi/tblsection"
s.anonymous=false
s.addremove=true
s.sortable=true
s.extedit=e.url("shunt_rules","%s")
function s.create(t,e)
TypedSection.create(t,e)
luci.http.redirect(t.extedit:format(e))
end
function s.remove(i,a)
m.uci:foreach(t,"nodes",function(e)
if e["protocol"]and e["protocol"]=="_shunt"then
m:del(e[".name"],a)
end
end)
TypedSection.remove(i,a)
end
o=s:option(DummyValue,"remarks",translate("Remarks"))
end
return m
