local e=require"luci.passwall.api"
local t="passwall"
local a=e.datatypes
m=Map(t,"Sing-Box/Xray "..translate("Shunt Rule"))
m.redirect=e.url()
e.set_apply_on_parse(m)
s=m:section(NamedSection,arg[1],"shunt_rules","")
s.addremove=false
s.dynamic=false
remarks=s:option(Value,"remarks",translate("Remarks"))
remarks.default=arg[1]
remarks.rmempty=false
protocol=s:option(MultiValue,"protocol",translate("Protocol"))
protocol:value("http")
protocol:value("tls")
protocol:value("bittorrent")
o=s:option(MultiValue,"inbound",translate("Inbound Tag"))
o:value("tproxy",translate("Transparent proxy"))
o:value("socks","Socks")
network=s:option(ListValue,"network",translate("Network"))
network:value("tcp,udp","TCP UDP")
network:value("tcp","TCP")
network:value("udp","UDP")
source=s:option(DynamicList,"source",translate("Source"))
source.description="<ul><li>"..translate("Example:")
.."</li><li>"..translate("IP")..": 192.168.1.100"
.."</li><li>"..translate("IP CIDR")..": 192.168.1.0/24"
.."</li><li>"..translate("GeoIP")..": geoip:private"
.."</li></ul>"
source.cast="string"
source.cfgvalue=function(t,a)
local e
if t.tag_error[a]then
e=t:formvalue(a)
else
e=t.map:get(a,t.option)
if type(e)=="string"then
local t={}
string.gsub(e,'[^'.." "..']+',function(e)table.insert(t,e)end)
e=t
end
end
return e
end
source.validate=function(n,i,s)
local e={}
for o,t in ipairs(i)do
local o=false
if a.ip4addr(t)then
o=true
end
if o==false and t:find("geoip:")and t:find("geoip:")==1 then
o=true
end
if o==false then
e[#e+1]=t
end
end
if#e>0 then
n:add_error(s,"invalid",translate("Not true format, please re-enter!"))
for t,e in ipairs(e)do
n:add_error(s,"invalid",e)
end
end
return i
end
local e=function(n,i,a)
local e={}
local o={}
if type(a)=="table"then
local t
for a,t in ipairs(a)do
if t and#t>0 then
if not o[t]then
o[t]=t
e[#e+1]=t
end
end
end
else
e={a}
end
e=table.concat(e," ")
return DynamicList.write(n,i,e)
end
source.write=e
sourcePort=s:option(Value,"sourcePort",translate("Source port"))
port=s:option(Value,"port",translate("port"))
domain_list=s:option(TextValue,"domain_list",translate("Domain"))
domain_list.rows=10
domain_list.wrap="off"
domain_list.validate=function(e,o)
local e={}
o=o:gsub("^%s+",""):gsub("%s+$","\n"):gsub("\r\n","\n"):gsub("[ \t]*\n[ \t]*","\n")
string.gsub(o,"[^\r\n]+",function(t)table.insert(e,t)end)
for t,e in ipairs(e)do
local t=1
local o=e
if not e:find("#")and e:find("%s")then
elseif e:find("regexp:")and e:find("regexp:")==1 then
t=0
elseif e:find("domain:.")and e:find("domain:.")==1 then
o=e:gsub("domain:","")
elseif e:find("full:.")and e:find("full:.")==1 then
o=e:gsub("full:","")
elseif e:find("geosite:")and e:find("geosite:")==1 then
t=0
elseif e:find("ext:")and e:find("ext:")==1 then
t=0
elseif e:find("#")and e:find("#")==1 then
t=0
end
if t==1 then
if not a.hostname(o)then
return nil,o.." "..translate("Not valid domain name, please re-enter!")
end
end
end
return o
end
domain_list.description="<br /><ul><li>"..translate("Plaintext: If this string matches any part of the targeting domain, this rule takes effet. Example: rule 'sina.com' matches targeting domain 'sina.com', 'sina.com.cn' and 'www.sina.com', but not 'sina.cn'.")
.."</li><li>"..translate("Regular expression: Begining with 'regexp:', the rest is a regular expression. When the regexp matches targeting domain, this rule takes effect. Example: rule 'regexp:\\.goo.*\\.com$' matches 'www.google.com' and 'fonts.googleapis.com', but not 'google.com'.")
.."</li><li>"..translate("Subdomain (recommended): Begining with 'domain:' and the rest is a domain. When the targeting domain is exactly the value, or is a subdomain of the value, this rule takes effect. Example: rule 'domain:v2ray.com' matches 'www.v2ray.com', 'v2ray.com', but not 'xv2ray.com'.")
.."</li><li>"..translate("Full domain: Begining with 'full:' and the rest is a domain. When the targeting domain is exactly the value, the rule takes effect. Example: rule 'domain:v2ray.com' matches 'v2ray.com', but not 'www.v2ray.com'.")
.."</li><li>"..translate("Pre-defined domain list: Begining with 'geosite:' and the rest is a name, such as geosite:google or geosite:cn.")
.."</li><li>"..translate("Annotation: Begining with #")
.."</li></ul>"
ip_list=s:option(TextValue,"ip_list","IP")
ip_list.rows=10
ip_list.wrap="off"
ip_list.validate=function(e,t)
local e={}
t=t:gsub("^%s+",""):gsub("%s+$","\n"):gsub("\r\n","\n"):gsub("[ \t]*\n[ \t]*","\n")
string.gsub(t,"[^\r\n]+",function(t)table.insert(e,t)end)
for t,e in ipairs(e)do
if e:find("geoip:")and e:find("geoip:")==1 and not e:find("%s")then
elseif e:find("ext:")and e:find("ext:")==1 and not e:find("%s")then
elseif e:find("#")and e:find("#")==1 then
else
if not(a.ipmask4(e)or a.ipmask6(e))then
return nil,e.." "..translate("Not valid IP format, please re-enter!")
end
end
end
return t
end
ip_list.description="<br /><ul><li>"..translate("IP: such as '127.0.0.1'.")
.."</li><li>"..translate("CIDR: such as '127.0.0.0/8'.")
.."</li><li>"..translate("GeoIP: such as 'geoip:cn'. It begins with geoip: (lower case) and followed by two letter of country code.")
.."</li><li>"..translate("Annotation: Begining with #")
.."</li></ul>"
return m
