local s,t=...
local a=require"luci.passwall.api"
if not a.finded_com("xray")then
return
end
local r=a.fs
local n="Xray"
local h="xray_"
local function e(e)
return h..e
end
local l={
"aes-128-gcm","aes-256-gcm","chacha20-poly1305","xchacha20-poly1305","2022-blake3-aes-128-gcm","2022-blake3-aes-256-gcm","2022-blake3-chacha20-poly1305"
}
local d={
"none","srtp","utp","wechat-video","dtls","wireguard"
}
t.fields["type"]:value(n,"Xray")
o=t:option(ListValue,e("protocol"),translate("Protocol"))
o:value("vmess","Vmess")
o:value("vless","VLESS")
o:value("http","HTTP")
o:value("socks","Socks")
o:value("shadowsocks","Shadowsocks")
o:value("trojan","Trojan")
o:value("dokodemo-door","dokodemo-door")
o=t:option(Value,e("port"),translate("Listen Port"))
o.datatype="port"
o=t:option(Flag,e("auth"),translate("Auth"))
o.validate=function(n,a,i)
if a and a=="1"then
local a=t.fields[e("username")]and t.fields[e("username")]:formvalue(i)or""
local e=t.fields[e("password")]and t.fields[e("password")]:formvalue(i)or""
if a==""or e==""then
return nil,translate("Username and Password must be used together!")
end
end
return a
end
o:depends({[e("protocol")]="socks"})
o:depends({[e("protocol")]="http"})
o=t:option(Value,e("username"),translate("Username"))
o:depends({[e("auth")]=true})
o=t:option(Value,e("password"),translate("Password"))
o.password=true
o:depends({[e("auth")]=true})
o:depends({[e("protocol")]="shadowsocks"})
o=t:option(ListValue,e("d_protocol"),translate("Destination protocol"))
o:value("tcp","TCP")
o:value("udp","UDP")
o:value("tcp,udp","TCP,UDP")
o:depends({[e("protocol")]="dokodemo-door"})
o=t:option(Value,e("d_address"),translate("Destination address"))
o:depends({[e("protocol")]="dokodemo-door"})
o=t:option(Value,e("d_port"),translate("Destination port"))
o.datatype="port"
o:depends({[e("protocol")]="dokodemo-door"})
o=t:option(Value,e("decryption"),translate("Encrypt Method"))
o.default="none"
o:depends({[e("protocol")]="vless"})
o=t:option(ListValue,e("x_ss_method"),translate("Encrypt Method"))
o.rewrite_option="method"
for t,e in ipairs(l)do o:value(e)end
o:depends({[e("protocol")]="shadowsocks"})
o=t:option(Flag,e("iv_check"),translate("IV Check"))
o:depends({[e("protocol")]="shadowsocks"})
o=t:option(ListValue,e("ss_network"),translate("Transport"))
o.default="tcp,udp"
o:value("tcp","TCP")
o:value("udp","UDP")
o:value("tcp,udp","TCP,UDP")
o:depends({[e("protocol")]="shadowsocks"})
o=t:option(Flag,e("udp_forward"),translate("UDP Forward"))
o.default="1"
o.rmempty=false
o:depends({[e("protocol")]="socks"})
o=t:option(DynamicList,e("uuid"),translate("ID").."/"..translate("Password"))
for e=1,3 do
o:value(a.gen_uuid(1))
end
o:depends({[e("protocol")]="vmess"})
o:depends({[e("protocol")]="vless"})
o:depends({[e("protocol")]="trojan"})
o=t:option(ListValue,e("flow"),translate("flow"))
o.default=""
o:value("",translate("Disable"))
o:value("xtls-rprx-vision")
o:depends({[e("protocol")]="vless",[e("tls")]=true,[e("transport")]="raw"})
o=t:option(Flag,e("tls"),translate("TLS"))
o.default=0
o.validate=function(n,a,i)
if a then
local o=t.fields[e("reality")]and t.fields[e("reality")]:formvalue(i)or nil
if o and o=="1"then return a end
if a=="1"then
local a=t.fields[e("tls_certificateFile")]and t.fields[e("tls_certificateFile")]:formvalue(i)or""
local e=t.fields[e("tls_keyFile")]and t.fields[e("tls_keyFile")]:formvalue(i)or""
if a==""or e==""then
return nil,translate("Public key and Private key path can not be empty!")
end
end
return a
end
end
o:depends({[e("protocol")]="vmess"})
o:depends({[e("protocol")]="vless"})
o:depends({[e("protocol")]="http"})
o:depends({[e("protocol")]="socks"})
o:depends({[e("protocol")]="shadowsocks"})
o:depends({[e("protocol")]="trojan"})
o=t:option(Flag,e("reality"),translate("REALITY"))
o.default=0
o:depends({[e("tls")]=true})
o=t:option(Value,e("reality_private_key"),translate("Private Key"))
o:depends({[e("reality")]=true})
o=t:option(DynamicList,e("reality_shortId"),translate("Short Id"))
o:depends({[e("reality")]=true})
o=t:option(Value,e("reality_dest"),translate("Dest"))
o.default="google.com:443"
o:depends({[e("reality")]=true})
o=t:option(DynamicList,e("reality_serverNames"),translate("serverNames"))
o:depends({[e("reality")]=true})
function o.write(s,n,a)
local t={}
local i={}
if type(a)=="table"then
local e
for a,e in ipairs(a)do
if e and#e>0 then
if not i[e]then
i[e]=e
t[#t+1]=e
end
end
end
else
t={a}
end
return DynamicList.write(s,n,t)
end
o=t:option(ListValue,e("alpn"),translate("alpn"))
o.default="h2,http/1.1"
o:value("h3")
o:value("h2")
o:value("h3,h2")
o:value("http/1.1")
o:value("h2,http/1.1")
o:value("h3,h2,http/1.1")
o:depends({[e("tls")]=true})
o=t:option(FileUpload,e("tls_certificateFile"),translate("Public key absolute path"),translate("as:").."/etc/ssl/fullchain.pem")
o.default=s:get(t.section,"tls_certificateFile")or"/etc/config/ssl/"..arg[1]..".pem"
o:depends({[e("tls")]=true,[e("reality")]=false})
o.validate=function(t,e,t)
if e and e~=""then
if not r.access(e)then
return nil,translate("Can't find this file!")
else
return e
end
end
return nil
end
o=t:option(FileUpload,e("tls_keyFile"),translate("Private key absolute path"),translate("as:").."/etc/ssl/private.key")
o.default=s:get(t.section,"tls_keyFile")or"/etc/config/ssl/"..arg[1]..".key"
o:depends({[e("tls")]=true,[e("reality")]=false})
o.validate=function(t,e,t)
if e and e~=""then
if not r.access(e)then
return nil,translate("Can't find this file!")
else
return e
end
end
return nil
end
o=t:option(ListValue,e("transport"),translate("Transport"))
o:value("raw","RAW")
o:value("mkcp","mKCP")
o:value("ws","WebSocket")
o:value("ds","DomainSocket")
o:value("quic","QUIC")
o:value("grpc","gRPC")
o:value("httpupgrade","HttpUpgrade")
o:value("xhttp","XHTTP")
o:depends({[e("protocol")]="vmess"})
o:depends({[e("protocol")]="vless"})
o:depends({[e("protocol")]="socks"})
o:depends({[e("protocol")]="shadowsocks"})
o:depends({[e("protocol")]="trojan"})
o=t:option(Value,e("ws_host"),translate("WebSocket Host"))
o:depends({[e("transport")]="ws"})
o=t:option(Value,e("ws_path"),translate("WebSocket Path"))
o:depends({[e("transport")]="ws"})
o=t:option(Value,e("httpupgrade_host"),translate("HttpUpgrade Host"))
o:depends({[e("transport")]="httpupgrade"})
o=t:option(Value,e("httpupgrade_path"),translate("HttpUpgrade Path"))
o.placeholder="/"
o:depends({[e("transport")]="httpupgrade"})
o=t:option(Value,e("xhttp_host"),translate("XHTTP Host"))
o:depends({[e("transport")]="xhttp"})
o=t:option(Value,e("xhttp_path"),translate("XHTTP Path"))
o.placeholder="/"
o:depends({[e("transport")]="xhttp"})
o=t:option(Value,e("xhttp_maxuploadsize"),translate("maxUploadSize"))
o.default="1000000"
o:depends({[e("transport")]="xhttp"})
o=t:option(Value,e("xhttp_maxconcurrentuploads"),translate("maxConcurrentUploads"))
o.default="10"
o:depends({[e("transport")]="xhttp"})
o=t:option(ListValue,e("tcp_guise"),translate("Camouflage Type"))
o:value("none","none")
o:value("http","http")
o:depends({[e("transport")]="raw"})
o=t:option(DynamicList,e("tcp_guise_http_host"),translate("HTTP Host"))
o:depends({[e("tcp_guise")]="http"})
o=t:option(DynamicList,e("tcp_guise_http_path"),translate("HTTP Path"))
o:depends({[e("tcp_guise")]="http"})
o=t:option(ListValue,e("mkcp_guise"),translate("Camouflage Type"),translate('<br />none: default, no masquerade, data sent is packets with no characteristics.<br />srtp: disguised as an SRTP packet, it will be recognized as video call data (such as FaceTime).<br />utp: packets disguised as uTP will be recognized as bittorrent downloaded data.<br />wechat-video: packets disguised as WeChat video calls.<br />dtls: disguised as DTLS 1.2 packet.<br />wireguard: disguised as a WireGuard packet. (not really WireGuard protocol)'))
for t,e in ipairs(d)do o:value(e)end
o:depends({[e("transport")]="mkcp"})
o=t:option(Value,e("mkcp_mtu"),translate("KCP MTU"))
o.default="1350"
o:depends({[e("transport")]="mkcp"})
o=t:option(Value,e("mkcp_tti"),translate("KCP TTI"))
o.default="20"
o:depends({[e("transport")]="mkcp"})
o=t:option(Value,e("mkcp_uplinkCapacity"),translate("KCP uplinkCapacity"))
o.default="5"
o:depends({[e("transport")]="mkcp"})
o=t:option(Value,e("mkcp_downlinkCapacity"),translate("KCP downlinkCapacity"))
o.default="20"
o:depends({[e("transport")]="mkcp"})
o=t:option(Flag,e("mkcp_congestion"),translate("KCP Congestion"))
o:depends({[e("transport")]="mkcp"})
o=t:option(Value,e("mkcp_readBufferSize"),translate("KCP readBufferSize"))
o.default="1"
o:depends({[e("transport")]="mkcp"})
o=t:option(Value,e("mkcp_writeBufferSize"),translate("KCP writeBufferSize"))
o.default="1"
o:depends({[e("transport")]="mkcp"})
o=t:option(Value,e("mkcp_seed"),translate("KCP Seed"))
o:depends({[e("transport")]="mkcp"})
o=t:option(Value,e("ds_path"),"Path",translate("A legal file path. This file must not exist before running."))
o:depends({[e("transport")]="ds"})
o=t:option(ListValue,e("quic_security"),translate("Encrypt Method"))
o:value("none")
o:value("aes-128-gcm")
o:value("chacha20-poly1305")
o:depends({[e("transport")]="quic"})
o=t:option(Value,e("quic_key"),translate("Encrypt Method")..translate("Key"))
o:depends({[e("transport")]="quic"})
o=t:option(ListValue,e("quic_guise"),translate("Camouflage Type"))
for t,e in ipairs(d)do o:value(e)end
o:depends({[e("transport")]="quic"})
o=t:option(Value,e("grpc_serviceName"),"ServiceName")
o:depends({[e("transport")]="grpc"})
o=t:option(Flag,e("acceptProxyProtocol"),translate("acceptProxyProtocol"),translate("Whether to receive PROXY protocol, when this node want to be fallback or forwarded by proxy, it must be enable, otherwise it cannot be used."))
o.default="0"
o=t:option(Flag,e("fallback"),translate("Fallback"))
o:depends({[e("protocol")]="vless",[e("transport")]="raw"})
o:depends({[e("protocol")]="trojan",[e("transport")]="raw"})
o=t:option(DynamicList,e("fallback_list"),"Fallback",translate("format: dest,path,xver"))
o:depends({[e("fallback")]=true})
o=t:option(Flag,e("bind_local"),translate("Bind Local"),translate("When selected, it can only be accessed localhost."))
o.default="0"
o=t:option(Flag,e("accept_lan"),translate("Accept LAN Access"),translate("When selected, it can accessed lan , this will not be safe!"))
o.default="0"
local i={}
for t,e in ipairs(a.get_valid_nodes())do
if e.node_type=="normal"and e.type==n then
i[#i+1]={
id=e[".name"],
remarks=e["remark"]
}
end
end
o=t:option(ListValue,e("outbound_node"),translate("outbound node"))
o:value("",translate("Close"))
o:value("_socks",translate("Custom Socks"))
o:value("_http",translate("Custom HTTP"))
o:value("_iface",translate("Custom Interface"))
for t,e in pairs(i)do o:value(e.id,e.remarks)end
o=t:option(Value,e("outbound_node_address"),translate("Address (Support Domain Name)"))
o:depends({[e("outbound_node")]="_socks"})
o:depends({[e("outbound_node")]="_http"})
o=t:option(Value,e("outbound_node_port"),translate("Port"))
o.datatype="port"
o:depends({[e("outbound_node")]="_socks"})
o:depends({[e("outbound_node")]="_http"})
o=t:option(Value,e("outbound_node_username"),translate("Username"))
o:depends({[e("outbound_node")]="_socks"})
o:depends({[e("outbound_node")]="_http"})
o=t:option(Value,e("outbound_node_password"),translate("Password"))
o.password=true
o:depends({[e("outbound_node")]="_socks"})
o:depends({[e("outbound_node")]="_http"})
o=t:option(Value,e("outbound_node_iface"),translate("Interface"))
o.default="eth1"
o:depends({[e("outbound_node")]="_iface"})
o=t:option(Flag,e("log"),translate("Log"))
o.default="1"
o.rmempty=false
o=t:option(ListValue,e("loglevel"),translate("Log Level"))
o.default="warning"
o:value("debug")
o:value("info")
o:value("warning")
o:value("error")
o:depends({[e("log")]=true})
a.luci_types(arg[1],s,t,n,h)
