module("luci.passwall.api",package.seeall)
local t=require"luci.passwall.com"
bin=require"nixio".bin
fs=require"nixio.fs"
sys=require"luci.sys"
uci=require"luci.model.uci".cursor()
util=require"luci.util"
datatypes=require"luci.cbi.datatypes"
jsonc=require"luci.jsonc"
i18n=require"luci.i18n"
appname="passwall"
curl_args={"-skfL","--connect-timeout 3","--retry 3"}
command_timeout=300
OPENWRT_ARCH=nil
DISTRIB_ARCH=nil
OPENWRT_BOARD=nil
CACHE_PATH="/tmp/etc/"..appname.."_tmp"
LOG_FILE="/tmp/log/"..appname..".log"
TMP_PATH="/tmp/etc/"..appname
TMP_IFACE_PATH=TMP_PATH.."/iface"
function log(...)
local a=os.date("%Y-%m-%d %H:%M:%S: ")..table.concat({...}," ")
local e,t=io.open(LOG_FILE,"a")
if e and t==nil then
e:write(a.."\n")
e:close()
end
end
function is_js_luci()
return sys.call('[ -f "/www/luci-static/resources/uci.js" ]')==0
end
function is_old_uci()
return sys.call("grep -E 'require[ \t]*\"uci\"' /usr/lib/lua/luci/model/uci.lua >/dev/null 2>&1")==0
end
function set_apply_on_parse(e)
if not e then
return
end
if is_js_luci()then
e.apply_on_parse=false
e.on_after_apply=function(e)
showMsg_Redirect(e.redirect,3000)
end
end
end
function showMsg_Redirect(t,a)
local e="PassWall "..i18n.translate("Settings have been successfully saved and applied!")
luci.http.write([[
		<script type="text/javascript">
			document.addEventListener('DOMContentLoaded', function() {
				// 创建遮罩层
				var overlay = document.createElement('div');
				overlay.style.position = 'fixed';
				overlay.style.top = '0';
				overlay.style.left = '0';
				overlay.style.width = '100%';
				overlay.style.height = '100%';
				overlay.style.backgroundColor = 'rgba(0, 0, 0, 0.5)';
				overlay.style.zIndex = '9999';
				// 创建提示条
				var messageDiv = document.createElement('div');
				messageDiv.style.position = 'fixed';
				messageDiv.style.top = '0';
				messageDiv.style.left = '0';
				messageDiv.style.width = '100%';
				messageDiv.style.background = '#4caf50';
				messageDiv.style.color = '#fff';
				messageDiv.style.textAlign = 'center';
				messageDiv.style.padding = '10px';
				messageDiv.style.zIndex = '10000';
				messageDiv.textContent = ']]..e..[[';
				// 将遮罩层和提示条添加到页面
				document.body.appendChild(overlay);
				document.body.appendChild(messageDiv);
				// 重定向或隐藏提示条和遮罩层
				var redirectUrl = ']]..(t or"")..[[';
				var delay = ]]..(a or 3000)..[[;
				setTimeout(function() {
					if (redirectUrl) {
						window.location.href = redirectUrl;
					} else {
						if (messageDiv && messageDiv.parentNode) {
							messageDiv.parentNode.removeChild(messageDiv);
						}
						if (overlay && overlay.parentNode) {
							overlay.parentNode.removeChild(overlay);
						}
						window.location.href = window.location.href;
					}
				}, delay);
			});
		</script>
	]])
end
function uci_save(a,e,t,o)
if is_old_uci()then
a:save(e)
if t then
a:commit(e)
if o then
sys.call("/etc/init.d/"..e.." reload > /dev/null 2>&1 &")
end
end
else
t=true
if t then
if o then
a:commit(e)
else
sh_uci_commit(e)
end
end
end
end
function sh_uci_get(e,a,t)
exec_call(string.format("uci -q get %s.%s.%s",e,a,t))
end
function sh_uci_set(e,t,a,o,i)
exec_call(string.format("uci -q set %s.%s.%s=\"%s\"",e,t,a,o))
if i then sh_uci_commit(e)end
end
function sh_uci_del(e,t,o,a)
exec_call(string.format("uci -q delete %s.%s.%s",e,t,o))
if a then sh_uci_commit(e)end
end
function sh_uci_add_list(e,o,t,a,i)
exec_call(string.format("uci -q del_list %s.%s.%s=\"%s\"",e,o,t,a))
exec_call(string.format("uci -q add_list %s.%s.%s=\"%s\"",e,o,t,a))
if i then sh_uci_commit(e)end
end
function sh_uci_commit(e)
exec_call(string.format("uci -q commit %s",e))
end
function set_cache_var(e,t)
sys.call(string.format('/usr/share/passwall/app.sh set_cache_var %s "%s"',e,t))
end
function get_cache_var(e)
local e=sys.exec(string.format('echo -n $(/usr/share/passwall/app.sh get_cache_var %s)',e))
if e==""then e=nil end
return e
end
function exec_call(e)
local a=io.popen(e..'; echo -e "\n$?"')
local e={}
local t=""
local o
for t in a:lines()do
e[#e+1]=t
end
a:close()
if#e>0 then
o=e[#e]
for a=1,#e-1 do
t=t..e[a]..((a==#e-1)and""or"\n")
end
end
return tonumber(o),trim(t)
end
function base64Decode(e)
local a=e
if not e then return''end
e=e:gsub("%z","")
e=e:gsub("%c","")
e=e:gsub("_","/")
e=e:gsub("-","+")
local t=#e%4
e=e..string.sub('====',t+1)
local e=nixio.bin.b64decode(e)
if e then
return e:gsub("%z","")
else
return a
end
end
function get_domain_port_from_url(a)
local o,e,t=string.match(a,"^(https?)://([%w%.%-]+):?(%d*)")
if not e then
o,e,t=string.match(a,"^(https?)://(%b[])([^:/]*)/?")
end
if not e then return nil,nil end
if e:sub(1,1)=="["then e=e:sub(2,-2)end
t=t~=""and tonumber(t)or(o=="https"and 443 or 80)
if datatypes.ipaddr(e)or datatypes.ip6addr(e)then return nil,nil end
return e,t
end
function domainToIPv4(e,t)
local t=t or"223.5.5.5"
local e=luci.sys.exec('nslookup %s %s | awk \'/^Name:/{getline; if ($1 == "Address:") print $2}\''%{e,t})
for e in string.gmatch(e,"%S+")do
if datatypes.ipaddr(e)and not datatypes.ip6addr(e)then return e end
end
return nil
end
function curl_base(a,t,e)
if not e then e={}end
if t then
e[#e+1]="-o "..t
end
local e=string.format('curl %s "%s"',table_join(e),a)
return exec_call(e)
end
function curl_proxy(o,a,e)
local t=get_cache_var("GLOBAL_TCP_SOCKS_server")
if t and t~=""then
if not e then e={}end
local e=clone(e)
e[#e+1]="-x socks5h://"..t
return curl_base(o,a,e)
end
return nil,nil
end
function curl_logic(o,i,a)
local e,t=curl_proxy(o,i,a)
if not e or e~=0 then
e,t=curl_base(o,i,a)
end
return e,t
end
function curl_direct(a,o,e)
local t=uci:get(appname,"@global[0]","chn_list")or"direct"
local i=(t=="proxy")and"1.1.1.1"or"223.5.5.5"
if not e then e={}end
local t=clone(e)
local e,n=get_domain_port_from_url(a)
if e then
local a=domainToIPv4(e,i)
if a then
t[#t+1]="--resolve "..e..":"..n..":"..a
end
end
return curl_base(a,o,t)
end
function curl_auto(o,t,a)
local e,i=curl_proxy(o,t,a)
if not e or e~=0 then
e,i=curl_direct(o,t,a)
end
return e,i
end
function url(...)
local e=string.format("admin/services/%s",appname)
local t={...}
for a,t in pairs(t)do
if t~=""then
e=e.."/"..t
end
end
return require"luci.dispatcher".build_url(e)
end
function trim(e)
return(e:gsub("^%s*(.-)%s*$","%1"))
end
function split(e,o)
if e then
e=e:gsub("%z","")
local t,a=1,{}
while true do
local i,o=e:find(o,t)
if not o then
local e=string.sub(e,t,string.len(e))
if#e>0 then
table.insert(a,e)
end
break
else
table.insert(a,string.sub(e,t,i-1))
t=o+1
end
end
return a
end
return{}
end
function is_exist(e,t)
for a,e in ipairs(e)do
if e==t then
return true
end
end
return false
end
function repeat_exist(t,a)
local e=0
for o,t in ipairs(t)do
if t:find("-")and t==a then
e=e+1
end
end
if e>1 then
return true
end
return false
end
function remove(...)
for t,e in ipairs({...})do
if e and#e>0 and e~="/"then
sys.call(string.format("rm -rf %s",e))
end
end
end
function is_install(e)
if e and#e>0 then
local t="/usr/lib/opkg/info"
local a=".control"
local o=sys.call("[ -d "..t.." ]")
if o~=0 then
t="/lib/apk/packages"
a=".list"
end
return sys.call(string.format('[ -s "%s/%s%s" ]',t,e,a))==0
end
return false
end
function get_args(e)
local a={}
for t,o in pairs(e)do
if t>0 then
local t=e[t+1]
if t then
if repeat_exist(e,t)==false then
a[o]=t
end
end
end
end
return a
end
function get_function_args(e)
local a=nil
if e and#e>1 then
local t={}
for o=2,#e do
t[#t+1]=e[o]
end
a=get_args(t)
end
return a
end
function strToTable(e)
if e==nil or type(e)~="string"then
return{}
end
return loadstring("return "..e)()
end
function is_normal_node(e)
if e and e.type and e.protocol and(e.protocol=="_balancing"or e.protocol=="_shunt"or e.protocol=="_iface"or e.protocol=="_urltest")then
return false
end
return true
end
function is_special_node(e)
return is_normal_node(e)==false
end
function is_ip(e)
if is_ipv6(e)then
e=get_ipv6_only(e)
end
return datatypes.ipaddr(e)
end
function is_ipv6(t)
local e=t
local t=t:match('%[(.*)%]')
if t then
e=t
end
if datatypes.ip6addr(e)then
return true
end
return false
end
function is_ipv6addrport(e)
if is_ipv6(e)then
local t,e=e:match('%[(.*)%]:([^:]+)$')
if e then
return datatypes.port(e)
end
end
return false
end
function get_ipv6_only(e)
local t=""
if is_ipv6(e)then
t=e
if e:match('%[(.*)%]')then
t=e:match('%[(.*)%]')
end
end
return t
end
function get_ipv6_full(t)
local e=""
if is_ipv6(t)then
e=t
if not t:match('%[(.*)%]')then
e="["..e.."]"
end
end
return e
end
function get_ip_type(e)
if is_ipv6(e)then
return"6"
elseif datatypes.ip4addr(e)then
return"4"
end
return""
end
function is_mac(e)
return datatypes.macaddr(e)
end
function ip_or_mac(e)
if e then
if get_ip_type(e)=="4"then
return"ip"
end
if is_mac(e)then
return"mac"
end
end
return""
end
function iprange(e)
if e then
local t,e=e:match("^([^/]+)-([^/]+)$")
if(t and datatypes.ip4addr(t))and(e and datatypes.ip4addr(e))then
return true
end
end
return false
end
function get_domain_from_url(e)
local t=string.match(e,"//([^/]+)")
if t then
return t
end
return e
end
function get_valid_nodes()
local i=uci_get_type("@global_other[0]","show_node_info","0")
local o={}
uci:foreach(appname,"nodes",function(e)
e.id=e[".name"]
if e.type and e.remarks then
if(e.type=="sing-box"or e.type=="Xray")and e.protocol and
(e.protocol=="_balancing"or e.protocol=="_shunt"or e.protocol=="_iface"or e.protocol=="_urltest")then
local t=e.type
if t=="sing-box"then t="Sing-Box"end
e["remark"]="%s：[%s] "%{t.." "..i18n.translatef(e.protocol),e.remarks}
e["node_type"]="special"
o[#o+1]=e
end
if e.port and e.address then
local a=e.address
if is_ip(a)or datatypes.hostname(a)then
local t=e.type
if(t=="sing-box"or t=="Xray")and e.protocol then
local e=e.protocol
if e=="vmess"then
e="VMess"
elseif e=="vless"then
e="VLESS"
elseif e=="shadowsocks"then
e="SS"
elseif e=="shadowsocksr"then
e="SSR"
elseif e=="wireguard"then
e="WG"
elseif e=="hysteria"then
e="HY"
elseif e=="hysteria2"then
e="HY2"
else
e=e:gsub("^%l",string.upper)
end
if t=="sing-box"then t="Sing-Box"end
t=t.." "..e
end
if is_ipv6(a)then a=get_ipv6_full(a)end
e["remark"]="%s：[%s]"%{t,e.remarks}
if i=="1"then
e["remark"]="%s：[%s] %s:%s"%{t,e.remarks,a,e.port}
end
e.node_type="normal"
o[#o+1]=e
end
end
end
end)
return o
end
function get_node_remarks(e)
local a=""
if e then
if(e.type=="sing-box"or e.type=="Xray")and e.protocol and
(e.protocol=="_balancing"or e.protocol=="_shunt"or e.protocol=="_iface"or e.protocol=="_urltest")then
a="%s：[%s] "%{e.type.." "..i18n.translatef(e.protocol),e.remarks}
else
local t=e.type
if(e.type=="sing-box"or e.type=="Xray")and e.protocol then
local e=e.protocol
if e=="vmess"then
e="VMess"
elseif e=="vless"then
e="VLESS"
elseif e=="shadowsocks"then
e="SS"
elseif e=="shadowsocksr"then
e="SSR"
elseif e=="wireguard"then
e="WG"
elseif e=="hysteria"then
e="HY"
elseif e=="hysteria2"then
e="HY2"
else
e=e:gsub("^%l",string.upper)
end
if t=="sing-box"then t="Sing-Box"end
t=t.." "..e
end
a="%s：[%s]"%{t,e.remarks}
end
end
return a
end
function get_full_node_remarks(e)
local t=get_node_remarks(e)
if#t>0 then
if e.address and e.port then
t=t.." "..e.address..":"..e.port
end
end
return t
end
function gen_uuid(t)
local e=sys.exec("echo -n $(cat /proc/sys/kernel/random/uuid)")
if t==nil then
e=string.gsub(e,"-","")
end
return e
end
function gen_short_uuid()
return sys.exec("echo -n $(head /dev/urandom | tr -dc A-Za-z0-9 | head -c 8)")
end
function uci_get_type(t,a,e)
local t=uci:get(appname,t,a)or e
if(t==nil or t=="")and(e and e~="")then
t=e
end
return t
end
local function i(e)
if e and e~=""then
if not fs.access(e,"rwx","rx","rx")then
fs.chmod(e,755)
end
end
end
function get_customed_path(e)
return uci_get_type("@global_app[0]",e.."_file")
end
function finded_com(e)
local e=get_app_path(e)
if not e then return end
local e=luci.sys.exec('echo -n $(type -t -p "%s" | head -n1)'%{e})
if e==""then
e=nil
end
return e
end
function finded(e)
return luci.sys.exec('echo -n $(type -t -p "/bin/%s" -p "/usr/bin/%s" "%s" | head -n1)'%{e,e,e})
end
function is_finded(e)
return finded(e)~=""and true or false
end
function clone(i)
local function o(t,e)
for a,t in pairs(t)do
if type(t)~="table"then
e[a]=t;
else
e[a]={};
o(t,e[a])
end
end
end
local e={}
o(i,e)
return e
end
function get_bin_version_cache(e,a)
sys.call("mkdir -p /tmp/etc/passwall_tmp")
if fs.access(e)then
i(e)
local t=sys.exec("echo -n $(md5sum "..e.." | awk '{print $1}')")
if fs.access("/tmp/etc/passwall_tmp/"..t)then
return sys.exec("echo -n $(cat /tmp/etc/passwall_tmp/%s)"%t)
else
local e=sys.exec(string.format("echo -n $(%s %s)",e,a))
if e and e~=""then
sys.call("echo '"..e.."' > ".."/tmp/etc/passwall_tmp/"..t)
return e
end
end
end
return""
end
function get_app_path(e)
if t[e]then
local t=t[e].default_path
local e=uci_get_type("@global_app[0]",e:gsub("%-","_").."_file")
e=e and(#e>0 and e or t)or t
return e
end
end
function get_app_version(a,e)
if e==nil then e=get_app_path(a)end
return get_bin_version_cache(e,t[a].cmd_version)
end
local function e(e)
if e and#e>1 then
if sys.exec('[ -f "%s" ] && echo -n 1'%e)=="1"then
return true
end
end
return nil
end
local function a(e)
if e and#e>1 then
if sys.exec('[ -d "%s" ] && echo -n 1'%e)=="1"then
return true
end
end
return nil
end
local function l(e)
if a(e)then
return e
else
return l(fs.dirname(e))
end
end
local function r(e)
if e==nil then e="/"end
if sys.call("df -k "..e.." >/dev/null 2>&1")==0 then
return tonumber(sys.exec("echo -n $(df -k "..e.." | awk 'NR>1' | awk '{print $4}')"))
end
return 0
end
local function d(e)
if e==nil then return 0 end
if fs.access(e)then
return tonumber(sys.exec("echo -n $(du -k "..e.." | awk '{print $1}')"))
end
return 0
end
function _unpack(t,e)
e=e or 1
if t[e]~=nil then return t[e],_unpack(t,e+1)end
end
function table_join(t,a)
if not a then
a=" "
end
local e=""
for o,i in ipairs(t)do
e=e..t[o]..(o==#t and""or a)
end
return e
end
local function i(r,h,a,i)
local o=require"os"
local e=require"nixio"
local s,n=e.pipe()
local t=e.fork()
if t>0 then
n:close()
if a or i then
local n=o.time()
while true do
if i and o.difftime(o.time(),n)>=i then
e.kill(t,e.const.SIGTERM)
return 1
end
if a then
local e=s:read(2048)
if e and#e>0 then
a(e)
end
end
local n,o,t=e.waitpid(t,"nohang")
if n and o=="exited"then return t end
if not a and i then e.nanosleep(1)end
end
else
local e,t,a=e.waitpid(t)
return e and t=="exited"and a
end
elseif t==0 then
e.dup(n,e.stdout)
s:close()
n:close()
e.exece(r,h,nil)
e.stdout:close()
o.exit(1)
end
end
function compare_versions(a,e,t)
local o=table
if not a then a=""end
if not t then t=""end
local a=util.split(a,"[%.%-]",nil,true)
local i=util.split(t,"[%.%-]",nil,true)
local t=o.getn(a)
local o=o.getn(i)
if(t<o)then t=o end
for t=1,t,1 do
local a=tonumber(a[t]or 0)or 0
local t=tonumber(i[t]or 0)or 0
if e=="~="and(a~=t)then return true end
if(e=="<"or e=="<=")and(a<t)then return true end
if(e==">"or e==">=")and(a>t)then return true end
if(a~=t)then return false end
end
return not(e=="<"or e==">")
end
local function n()
local e=nixio.uname().machine or""
if not OPENWRT_ARCH and fs.access("/usr/lib/os-release")then
OPENWRT_ARCH=sys.exec("echo -n $(grep 'OPENWRT_ARCH' /usr/lib/os-release | awk -F '[\\042\\047]' '{print $2}')")
OPENWRT_BOARD=sys.exec("echo -n $(grep 'OPENWRT_BOARD' /usr/lib/os-release | awk -F '[\\042\\047]' '{print $2}')")
if OPENWRT_ARCH==""then OPENWRT_ARCH=nil end
if OPENWRT_BOARD==""then OPENWRT_BOARD=nil end
end
if not DISTRIB_ARCH and fs.access("/etc/openwrt_release")then
DISTRIB_ARCH=sys.exec("echo -n $(grep 'DISTRIB_ARCH' /etc/openwrt_release | awk -F '[\\042\\047]' '{print $2}')")
if DISTRIB_ARCH==""then DISTRIB_ARCH=nil end
end
if e:match("^i[%d]86$")then
e="x86"
elseif e:match("armv5")then
e="armv5"
elseif e:match("armv6")then
e="armv6"
elseif e:match("armv7")then
e="armv7"
end
if OPENWRT_ARCH or DISTRIB_ARCH then
if e=="mips"then
if OPENWRT_ARCH and OPENWRT_ARCH:match("mipsel")=="mipsel"
or DISTRIB_ARCH and DISTRIB_ARCH:match("mipsel")=="mipsel"then
e="mipsel"
end
elseif e=="armv7"then
if OPENWRT_ARCH and not OPENWRT_ARCH:match("vfp")and not OPENWRT_ARCH:match("neon")
or DISTRIB_ARCH and not DISTRIB_ARCH:match("vfp")and not DISTRIB_ARCH:match("neon")then
e="armv5"
end
end
end
if e=="aarch64"and OPENWRT_BOARD and OPENWRT_BOARD:match("rockchip")~=nil then
e="rockchip"
end
return util.trim(e)
end
function parseURL(e)
if not e or e==""then
return nil
end
local t="^(%w+)://"
local a=e:match(t)
if not a then
return nil
end
local e=e:sub(#a+4)
local t="^([^@]+)@"
local t=e:match(t)
local o,i
if t then
o,i=t:match("^([^:]+):([^:]+)$")
e=e:sub(#t+2)
end
local t,e=e:match("^([^:]+):(%d+)$")
if not t or not e then
return nil
end
return{
protocol=a,
username=o,
password=i,
host=t,
port=tonumber(e)
}
end
local s={
x86_64="amd64",
x86="386",
aarch64="arm64",
rockchip="arm64",
mips="mips",
mips64="mips64",
mipsel="mipsel",
mips64el="mips64el",
armv5="arm.*5",
armv6="arm.*6[^4]*",
armv7="arm.*7",
armv8="arm64",
riscv64="riscv64"
}
local function u(e)
local a=require"luci.jsonc"
local t,e=curl_auto(e,nil,curl_args)
if t~=0 or e==""then return{}end
return a.parse(e)or{}
end
local function h(t)
local e=get_app_path(t)or""
if e==""then
return{
code=1,
error=i18n.translatef("You did not fill in the %s path. Please save and apply then update manually.",t)
}
end
return{
code=0,
app_path=e
}
end
function to_check(e,a)
local o=h(a)
if o.code~=0 then
return o
end
if not e or e==""then e=n()end
local e=t[a].file_tree[e]or s[e]or""
if e==""then
return{
code=1,
error=i18n.translate("Can't determine ARCH, or ARCH not supported.")
}
end
local i=get_app_version(a)
local n=string.format(t[a].match_fmt_str,e)
local e=u(t[a]:get_url())
if#e>0 then
e=e[1]
end
if e.tag_name==nil then
return{
code=1,
error=i18n.translate("Get remote version info failed.")
}
end
local o=e.tag_name
if t[a].remote_version_str_replace then
o=o:gsub(t[a].remote_version_str_replace,"")
end
local a=compare_versions(i:match("[^v]+"),"<",o:match("[^v]+"))
local t={}
for a,e in ipairs(e.assets)do
if e.name and e.name:match(n)then
t=e
break
end
end
if not t.browser_download_url then
return{
code=1,
local_version=i,
remote_version=o,
html_url=e.html_url,
data=t,
error=i18n.translate("New version found, but failed to get new version download url.")
}
end
return{
code=0,
has_update=a,
local_version=i,
remote_version=o,
html_url=e.html_url,
data=t
}
end
function to_download(a,e,n)
local o=h(a)
if o.code~=0 then
return o
end
if not e or e==""then
return{code=1,error=i18n.translate("Download url is required.")}
end
sys.call("/bin/rm -f /tmp/"..a.."_download.*")
local o=util.trim(util.exec("mktemp -u -t "..a.."_download.XXXXXX"))
if n then
local e=r("/tmp")
if tonumber(n)>tonumber(e)then
return{code=1,error=i18n.translatef("%s not enough space.","/tmp")}
end
end
local n=clone(curl_args)
table.insert(n,"-m 60")
local s,n=curl_auto(e,o,n)
n=s==0
if not n then
i("/bin/rm",{"-f",o})
return{
code=1,
error=i18n.translatef("File download failed or timed out: %s",e)
}
end
return{code=0,file=o,zip=t[a].zipped}
end
function to_extract(e,a,o)
local o=h(e)
if o.code~=0 then
return o
end
if not a or a==""or not fs.access(a)then
return{code=1,error=i18n.translate("File path required.")}
end
local o
if t[e].zipped then
if not t[e].zipped_suffix or t[e].zipped_suffix=="zip"then
o="unzip"
end
if t[e].zipped_suffix and t[e].zipped_suffix=="tar.gz"then
o="tar"
end
if o then
if sys.exec("echo -n $(command -v %s)"%{o})==""then
i("/bin/rm",{"-f",a})
return{
code=1,
error=i18n.translate("Not installed %s, Can't unzip!"%{o})
}
end
end
end
sys.call("/bin/rm -rf /tmp/"..e.."_extract.*")
local s=d(a)
local n=r("/tmp")
if n<=0 or n<=s then
return{code=1,error=i18n.translatef("%s not enough space.","/tmp")}
end
local n=util.trim(util.exec("mktemp -d -t "..e.."_extract.XXXXXX"))
local s={}
if o then
if o=="unzip"then
local t=sys.exec("echo -n $(command -v unzip)")
i(t,{"-o",a,e,"-d",n},function(e)s[#s+1]=e end)
elseif o=="tar"then
local o=sys.exec("echo -n $(command -v tar)")
if t[e].zipped_suffix=="tar.gz"then
i(o,{"-zxf",a,"-C",n},function(e)s[#s+1]=e end)
sys.call("/bin/mv -f "..n.."/*/"..t[e].name:lower().." "..n)
end
end
end
local e=util.split(table.concat(s))
i("/bin/rm",{"-f",a})
return{code=0,file=n}
end
function to_move(e,s)
local n=h(e)
if n.code~=0 then
return n
end
local a=n.app_path
local o=s
local h="/bin/rm -rf /tmp/"..e.."_download.*"
if fs.stat(s,"type")=="dir"then
o=s.."/"..t[e].name:lower()
h="/bin/rm -rf /tmp/"..e.."_extract.*"
end
if not s or s==""then
sys.call(h)
return{code=1,error=i18n.translate("Client file is required.")}
end
local t=get_app_version(e,o)
if t==""then
sys.call(h)
return{
code=1,
error=i18n.translate("The client file is not suitable for current device.")..e.."__"..o
}
end
local s=sys.call('pgrep -af "passwall/.*'..e..'" >/dev/null')
if s==0 then
sys.call("/etc/init.d/passwall stop")
end
local t=0
if fs.access(a)then
t=d(a)
end
local u=d(o)
local d=l(a)
local e=r(d)
if e>0 then
e=e+t
if u>e then
sys.call(h)
return{code=1,error=i18n.translatef("%s not enough space.",d)}
end
end
n=i("/bin/mv",{"-f",o,a},nil,command_timeout)==0
sys.call(h)
if s==0 then
sys.call("/etc/init.d/passwall restart >/dev/null 2>&1 &")
end
if not n or not fs.access(a)then
return{
code=1,
error=i18n.translatef("Can't move new file to path: %s",a)
}
end
return{code=0}
end
function get_version()
local e=sys.exec("opkg list-installed luci-app-passwall 2>/dev/null | awk '{print $3}'")
if not e or#e==0 then
e=sys.exec("apk list luci-app-passwall 2>/dev/null | awk '/installed/ {print $1}' | cut -d'-' -f4-")
end
return e or""
end
function to_check_self()
local e="https://raw.githubusercontent.com/xiaorouji/openwrt-passwall/main/luci-app-passwall/Makefile"
local t="/tmp/passwall_makefile"
local a,e=curl_auto(e,t,curl_args)
e=a==0
if not e then
i("/bin/rm",{"-f",t})
return{
code=1,
error=i18n.translatef("Failed")
}
end
local a=get_version()
local e=sys.exec("echo -n $(grep 'PKG_VERSION' /tmp/passwall_makefile|awk -F '=' '{print $2}')")
i("/bin/rm",{"-f",t})
local t=compare_versions(a,"<",e)
if not t then
return{
code=0,
local_version=a,
remote_version=e
}
end
return{
code=1,
has_update=true,
local_version=a,
remote_version=e,
error=i18n.translatef("The latest version: %s, currently does not support automatic update, if you need to update, please compile or download the ipk and then manually install.",e)
}
end
function luci_types(h,o,e,n,a)
local i={}
for t,s in pairs(e.fields)do
if t:find(a)==1 then
if not e.fields[t].not_rewrite then
if e.fields[t].rewrite_option then
if not i[e.fields[t].rewrite_option]then
i[e.fields[t].rewrite_option]=1
else
i[e.fields[t].rewrite_option]=i[e.fields[t].rewrite_option]+1
end
end
e.fields[t].cfgvalue=function(t,i)
if t.rewrite_option then
return o:get(i,t.rewrite_option)
else
if t.option:find(a)==1 then
return o:get(i,t.option:sub(1+#a))
end
end
end
e.fields[t].write=function(t,i,s)
if e.fields["type"]:formvalue(h)==n then
if t.custom_write then
t:custom_write(i,s)
else
if t.rewrite_option then
o:set(i,t.rewrite_option,s)
else
if t.option:find(a)==1 then
o:set(i,t.option:sub(1+#a),s)
end
end
end
end
end
e.fields[t].remove=function(t,s)
if e.fields["type"]:formvalue(h)==n then
if t.custom_remove then
t:custom_remove(s)
else
if t.rewrite_option and i[t.rewrite_option]==1 then
o:del(s,t.rewrite_option)
else
if t.option:find(a)==1 then
o:del(s,t.option:sub(1+#a))
end
end
end
end
end
end
local a=e.fields[t].deps
if#a>0 then
for e,t in ipairs(a)do
a[e]["type"]=n
end
else
e.fields[t]:depends({type=n})
end
end
end
end
function get_std_domain(e)
e=trim(e)
if e==""or e:find("#")then return""end
e=e:gsub("^[%.]+",""):gsub("[%.]+$","")
if e:find("%*")then
local t={}
for e in e:gmatch("[^%.]+")do
table.insert(t,e)
end
for e=#t,1,-1 do
if t[e]:find("%*")then
return t[e+1]and t[e+1].."."..table.concat(t,".",e+2)or""
end
end
end
return e
end
